/* sqw-ren.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Renaming, naming procedures.       楤 २  .
 *
 */

#include "./sqw-inc.h"

void Name_Check(char *, char *);
void Sqw_ren(char *, char *, char);
void RenameEXT(char *, char *);
void Sqw_Dup_Ren ();
void Sqw_Dup_Del ();

/* ========================================================================= */

/************  饣  ⥬ ६ *******************
 * It's  obvious, that SqWish gene-   祢,    ਬ  室  -
 * rates packets in outbound direc-   ४ਨ ,      ᮧ-
 * tory, and NOBODY do  it.  So  we    ⠬ 䠩. ⮬   ஢
 * can check existance  without any   稥 䠩,    ⮬,  -
 * chance, that such file  will  be    ஢મ  ⨥ 䠩  
 * created   between  checking  and   -  㬥 ᮧ 䠩   -
 * opening for writing.                 .
 * ------------------------------------------------------------------------ */
void Name_Check(char *newpath, char *pospath)
{
FILE *filetmp;
char *tmpos;
int  to_break;
while ((filetmp = fopen(newpath,rb)) != NULL)	/* ⨬ 横,  ⠪  */
      {						/* 䠩 .              */
      tmpos = pospath;
      to_break = 1;

      while ((*tmpos != BACKSLASH) && /*   ⪭       */
             (*tmpos != ':') &&       /* 稥                        */
             (tmpos >= newpath))      /*   砫                */
            {
            to_break = 0;
            if ((*tmpos)++ >= '9')
                {
                *tmpos-- = '0';
                to_break = 1;
                }
            else break;
            }
      fclose(filetmp);
      if (to_break) break; else;
      }
} /* Name_Check()*/

/******************************************************************************
This function renames *.~?? to *.c??   २ 䠩  *.~??   *.c??  
in path represented in path_ren; de-   ,  path_ren;  ࠭ *.~??
letes  *.~??  in path represented in    ,  path_del.  'c'  -
path_del. 'c' in above mask is given   ⮩ ᪥  symb_ren.
by symb_ren.
******************************************************************************/
void Sqw_ren (char *path_ren, char *path_del, char symb_ren)
{
char oldpath[MAXPATH+3];              /* +஥  ⭮ 䠩 */
char newpath[MAXPATH+3];              /* +   ⭮ 䠩 */
char *s0 = oldpath,                   /* 㪠⥫  ஬            */
     *s1 = newpath,                   /* 㪠⥫               */
     *s2 = path_ren,                  /* -  㥬            */
     *pospath = NULL;                 /* -     䠩      */
int lenpath = 0;                      /*                          */
struct ffblk fileblk;                 /*  㭪権 findfirst/findnext    */
/********************* ᯮ塞  ***********************************/
                                      /* 㥬         */
while (*s2 != '\0') {*s0++ = *s1++ = *s2++; lenpath++;}
strcpy(s0, Temporary);                /* 㥬  䠩         */

/* ###044 */
if (!findfirst(oldpath, &fileblk,(int)NULL))	/*     ⠪ */
   {
/*-------------------- ⢥ 横 २ ---------------------*/
   do  { /* while findnext */
       s0=oldpath+lenpath;            /* +஥  ⭮ 䠩 */
       s1=newpath+lenpath;            /* +   ⭮ 䠩 */
       s2=fileblk.ff_name;            /* ஥   䠩       */
       while (*s2 != '\0')            /* ନ  oldpath, newpath */
             {
             if (*s2 == '~') {*s0++ = '~'; *s1++=symb_ren; s2++;}
             else *s0++ = *s1++ = *s2++;
             if (*s2 == '.') pospath = s1; else;
             }
       *s0 = *s1 = '\0';
       pospath--;                     /* ᫥ ᨬ      */
       Name_Check(newpath,pospath);
       rename (oldpath,newpath);      /* ⢥ २        */
       }
   while (!findnext(&fileblk));		/* ###044 */
   }/* if !findfirst */
else;
/*-------------------- ࠭ 䠩 -----------------------------------*/
s0 = oldpath;
s2 = path_del;
lenpath = 0;
while (*s2 != '\0') {*s0++ = *s1++ = *s2++; lenpath++;}
strcpy(s0, Temporary);
if (!findfirst(oldpath, &fileblk, (int)NULL)) /* ###044 */
   {
   do  { /* while findnext */
       s0=oldpath+lenpath;
       s2=fileblk.ff_name;
       while (*s2 != '\0') *s0++ = *s2++;
       *s0 = '\0';
       remove (oldpath);
       }
   while (!findnext(&fileblk));		/* ###044 */
   }/* if !findfirst */
else;
}
/************* २ ७ 䠩 ****************************/
void RenameEXT(char *oldpath, char *t)
{
char newpath[MAXPATH+3];
char *pospath = newpath + strlen(oldpath) - LENEXT;
strcpy (newpath, oldpath);
strcpy (pospath, t);
pospath -= 2;
Name_Check(newpath, pospath);
rename (oldpath,newpath);      /* ⢥ २        */
}

static char Format_s_cc[] = "%s.~%c%c";
static char Format_sccc[] = "%s.%c%c%c";

/******************************************************************************
This function renames *.~?? to *.S??   २ 䠩  *.~??   *.S?? 
in all paths represented in Path_Lin    , ।⠢  Path_Lin.
******************************************************************************/
void Sqw_Dup_Ren ()
{
char oldpath[MAXPATH+3];              /* +஥  䠩 .~QW        */
char newpath[MAXPATH+3];              /* +   䠩 .SQW        */
char huge *s2 = Path_Lin;             /* -  㥬            */
unsigned int i;			      /* ⥪騩  宮	   */

/********************* ᯮ塞  ***********************************/
for (i = AREA1ST; i < Area_Num; i++)
    {
    sprintf (oldpath, Format_s_cc, s2, Qq, Ww);
    sprintf (newpath, Format_sccc, s2, Ss, Qq, Ww);
    if ((fileout = fopen(oldpath,rb)) != NULL)
	{
	fclose (fileout);
	remove (newpath);
	rename (oldpath, newpath);
	}
    else;
    s2 += Area[i].Path;
    } /* for i < Area_Num */
} /* Sqw_Dup_Ren() */

/******************************************************************************
This function deletes temporary *.~??  ࠭   ६  䠩  *.~?? 
in all paths represented in Path_Lin    , ।⠢  Path_Lin.
******************************************************************************/
void Sqw_Dup_Del ()
{
char oldpath[MAXPATH+3];              /* +஥  䠩 .~QW        */
char newpath[MAXPATH+3];              /* +   䠩 .SQW        */
char huge *s2 = Path_Lin;             /* -  㥬            */
unsigned int i;			      /* ⥪騩  宮	   */

/********************* ᯮ塞  ***********************************/
for (i = AREA1ST; i < Area_Num; i++)
    {
    sprintf (oldpath, Format_s_cc, s2, Qq, Ww);
    sprintf (newpath, Format_sccc, s2, Ss, Qq, Ww);
    if ((fileout = fopen(oldpath,rb)) != NULL)
	{
	fclose (fileout);
	if ((fileout = fopen(newpath,rb)) != NULL) /* ###030 */
		{
		fclose (fileout);
		remove (oldpath);
		}
	else	{
		fclose(fileout);
		rename (oldpath, newpath);
		}
	}
    else;
    s2 += Area[i].Path;
    } /* for i < Area_Num */
} /* Sqw_Dup_Del() */
