/* sqwish.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Main programm code.		       ᭮ ணࠬ.
 *
 * Here are the most memory alloca-    室 ᭮ 맮 ⢥
 * tion callings and checkings.         易  ⨬ ஢ન.
 *
 */

#include	"./sqw-inc.h"

static char	renaming_flg[] = "renaming.flg";
static void sqw_renflg(char *, char *);
static void sqw_delflg(char *);
#if AREAFIX_STYLE
static void sqw_ren1(char *, char *, unsigned long, unsigned long);
#endif
static char *pathnew(char *);
static char **RunExit_argv(void);

/************************** function Main **********************************/
void main (int argc, char *argv[])
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0		   */
#endif
ADDR	huge *Addr;	/* ६ ⠡窠 			   */
unsigned long lin_Num;	/* ⢮ ப  䠩 䨣樨	   */
unsigned int li = 0;	/* 稪 				   */
unsigned long Free_Memory; /* 쪮  ᢮ 	   */
unsigned long Need_Memory; /* 쪮    ?	   */
time_t time_begin;	/* ६  ணࠬ			   */
time_t time_finish;	/* ६ 襭 ணࠬ			   */
time_t ttx;		/* ﭨ 䫠  ⮢  MSGID .NUM	   */
struct ffblk fileblk;	/*   findfirst/findnext		   */
register int i;
int	Twit_Off = 0;	/* ਧ ⮣,   ⪫		    */

char *s0;		/* ⥫   ப/ᨢ 	    */
unsigned long l;	/* 稪   横			    */
unsigned long dupsize;	/* ᪮쪮 ॡ  ࠭ 㯮	    */
unsigned long lnksize;	/* ᪮쪮 ॡ  ⠡ 	    */
unsigned long arlsize;	/* ᪮쪮 ॡ  ⠡ ᪨	    */
#if AREAFIX_STYLE
unsigned long SizeOld;	/*  ⨬ ࠧ ண SquishCFG  */
unsigned long SizeNew;	/*  ⨬ ࠧ  SquishCFG   */
#endif
/* - - - - - - ⢥ ᯮ塞  - - - - - - - - - - - - - - - - - */
#if DEBUG
atexit(askwait);
#endif

AllocCheckConst(MINSEENBY, Buffer);

time(&time_begin);
/* ----------- 樠  ࠬ஢ 䨣 --------------- */
for (i = 0; i < Cfg_Verbs_Num; i++) Cfg[i] = 0;
Cfg_MaxMsgs = 80; Cfg_Duplicates = 10*DUPSTEP; Cfg_LogLevel = 5;
Cfg_CacheSize = 256;Cfg_MinUUEline = 30; Def_Pack[0] = '\0';
Cfg_BufSize=BUFSIZ; Cfg_KillDupes = 0; Cfg_MaxMsgPartLength = 12;
/* ======================= Command Line analysing first - config file name  */
#if (DEBUG && (defined(__TURBOC__)))
printf ("Borland Compiler version __TURBOC__ = 0x%0x\n", __TURBOC__);
#endif
sprintf (Buffer, sVersion, "Begin, ",
	SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
if (argc > 1)
   for (i = 1; i < argc; i++)
	{
	s0 = argv[i];
	if (*s0++ == '-')
	   {
	   if (toupper(*s0) == 'C')
	      if (s0[1]) sqwish_cfg = Sqw_ph(s0+1);
	      else {
		   if (++i == argc) break;
		   else sqwish_cfg = Sqw_ph(argv[i]);
		   continue;
		   }
	   else;

#define CommandKey(A,B) if (!stricmp(s0,(A))) { puts(B); exit(0); } else

CommandKey("-url", "ftp://ftp.pirit.com/pub/FIDO/sqwish/");
CommandKey("-version", Buffer + 7);

#undef CommandKey

#if (defined(UNIX) && (defined(Cfg_TildaHome)))
	   if  ((*s0) == '~')
		{
		Cfg_TildaHome = !Cfg_TildaHome;
		TildaHome = getenv("HOME");
		if (TildaHome) TildaHomeLen = strlen(TildaHome);
		else { TildaHome = empty; TildaHomeLen = 0; }
		}
	   else;
#endif /* (defined(UNIX) && (defined(Cfg_TildaHome))) */
	   if  (((*s0) == '?') || (!stricmp(s0,"-help")))
		{
		puts ("\n\nSqWitches (possible space between switch and it's parameter):\n");
		puts ("-cSQWISH.CFG\t- override current config file");
		puts ("-gCONFIG\t- override additional config files' path");
#if (!SYSLOGONLY)
		puts ("-nTOSSING.LOG\t- override log file");
#endif
		puts ("-iINBOUND\t- override inbound path");
		puts ("-oOUTBOUND.SQ\t- override outbound path");
		puts ("-bOUTBOUND\t- override bink outbound path");
		puts ("-hHOLD\t\t- override hold arcmail path");
		puts ("-fFLAGS\t\t- override flag files' path");
		puts ("-l\t\t- toggle Out*LowerCase mode");
		puts ("-t\t\t- toggle Secure + PointSecure mode");
		puts ("-q\t\t- toggle QuietArc mode");
		puts ("-k\t\t- toggle general KillDupes mode");
		puts ("-d\t\t- toggle CheckDate mode");
#if (defined(UNIX) && (defined(Cfg_TildaHome)))
		puts ("-~\t\t- ~ is translated to home directory");
#endif /* (defined(UNIX) && (defined(Cfg_TildaHome))) */
		puts ("--url\t\t- where to search me?");
		puts ("--version\t- version number");
		exit (0);
		} /* if  (((*s0) == '?') || (!stricmp(s0,"-help"))) */
	   else;
	   } /* if (*s0++ == '-') */
	else;
	} /* for i < argc */

printf ("(C) Sergej Qkowlew 2:5020/122 ");
printf ("%s", Buffer);

printf("\nAvailable memory %lu bytes\n", farcoreleft());

if ((filepkt = fopen(sqwish_cfg,rb)) == NULL) /* ࠭ 뫮 rt */
   Errexit("Can't open config file",Erl_Config);else;

lin_Num = Sqw_cr1(); /* === First Pass call ============================== */

/* ----------- Allocate memory for second pass --------------------------- */
AllocCheck(lin_Num, Line);
AllocCheckConst(1,My);
AllocCheckConst(SQW_MAXLINK,Addr);
Lin = Addr;						/* tmp link tables  */
/* - - - - - - - - - - override log from command line - - - - - - - - - - - */
#if (!SYSLOGONLY)

if (!Cfg_UseSyslog)
  {
  Cfg_TildaHome = 0;
  if (argc > 1)
    for (i = 1; i < argc; i++)
	{
	s0 = argv[i];
	if (*s0++ == '-')
	   {
	   if (*s0 == '~') Cfg_TildaHome = !Cfg_TildaHome; else;
	   if ((toupper(*s0++)) == 'N')
	      if (*s0) tossing_log = Sqw_ph(s0);
	      else {
		   if (++i == argc) break;
		   else tossing_log = Sqw_ph(argv[i]);
		   continue;
		   }
	   else;
	   }
	else;
	} /* for i < argc */
  if (tossing_log)			/* 㤥  && !SysLog) */
     Log_file = fopen(tossing_log, at); /* ஢ઠ  NULL  㭪樨 OutLog */
  else;
  if (Cfg_BufSize != BUFSIZ)
    {
    Buf_Log = malloc(Cfg_BufSize);
    if (Buf_Log && (Log_file != NULL))
	setvbuf(Log_file,Buf_Log,_IOFBF,Cfg_BufSize);
    else;
    }
  else;
  }
else
#endif /* !SYSLOGONLY */
#ifdef UNIX
	openlog("sqwish", LOG_PID | LOG_CONS, LOG_USER)
#endif
;

sprintf (Buffer, sVersion, "Begin,",
	SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
OutLog (LEV_START,Buffer);
/*-###046 */

time(&ttt);/* V03.04+ This line added here for Date_Before comparison */
Sqw_cr2(); /* ==== Second Pass call ====================================== */

/* ======================= Command Line analysing second - overrides	   */
Cfg_TildaHome = 0;
if (argc > 1)
   for (i = 1; i < argc; i++)
	{
	s0 = argv[i];
	if (*s0++ == '-')
	   switch(toupper(*s0++))
		{
#if (defined(UNIX) && (defined(Cfg_TildaHome)))
		case '~': Cfg_TildaHome = !Cfg_TildaHome; break;
#endif
		case 'T': Cfg_Secure = !Cfg_Secure;
			  Cfg_PointSecure = !Cfg_PointSecure; break;
		case 'Q': Cfg_QuietArc = !Cfg_QuietArc; break;
		case 'K': Cfg_KillDupes = !Cfg_KillDupes; break;
		case 'D': Cfg_CheckDate = !Cfg_CheckDate; break;
		case 'L': Cfg_OutFileLowerCase = !Cfg_OutFileLowerCase; break;
		case '?':;
		default:;
		case 'C': break;

#define Pkey(A,B,C,D) case A: if (*s0 == '\0') if (++i == argc) break; \
	else s0 = argv[i]; else; AllocPath(s0, B, C, D); break;

		Pkey('I', &InBound, LENNAME + LENEXT + 3, &Inb_Len);
		Pkey('O', &OutPath, LENNAME + LENEXT + 3, &Out_Len);
		Pkey('F', &FlagD, LENNAME + LENEXT + 3, &Flg_Len);
		Pkey('G', &Config, LENNAME + LENEXT + 3, &Cfg_Len);
		Pkey('H', &HoldPath, MAXADDPATH, &HoldLen);
		Pkey('B', &BinkPath, MAXADDPATH, &BinkLen);

		} /* switch toupper(*s0) */
	} /* for i < argc */

Buf_Pkt = malloc(Cfg_BufSize); /*  ࠢ ஢ઠ  setvbuf */
Buf_Out = malloc(Cfg_BufSize); /*  ࠢ ஢ઠ  setvbuf */

if ((Cfg_OutNames) && (BinkPath != NULL))
   if (HoldPath == NULL)
	AllocPath(BinkPath, &HoldPath, MAXADDPATH, &HoldLen);
   else;
else;
/* - - - - - - - Limit on command line length counting - - - - - - - - - - */
if (Cfg_MaxCommandLength && RunExit)
   {
   if (RunExit_argv() == NULL)
      {
      sprintf(Buffer,"RunExit: System can't execute command line longer than %i characters",
	   Cfg_MaxCommandLength);
      Errexit (Buffer, Erl_Syntax);
      }
   else;
   }
else;
/*------------- LowerCase filename text constants if needed -----------------*/
Sqw_tolower();
/*------------- Correct some paths if needed --------------------------------*/
if (squish_cfg == NULL) squish_cfg = sqwish_cfg; else;
/*------------- Reallocation memory, check global requirements --------------*/
if ((InBound == NULL) || (OutPath == NULL) || (My_Addr_Num == 0))
   Errexit ("Wrong NetFile, OutBound or Address!",Erl_Syntax); else;
if ((Link_Num == 0) || (Area_Num == AREA1ST))
   Errexit ("Nothing to do - no areas/links.",Erl_Syntax); else;

if (My_Addr_Num > 255)
   Errexit ("Too many our own addresses!",Erl_Syntax); else;
AllocCheck(My_Addr_Num, My);
AllocCheck((Link_Num+2), Link);
/******************* Copy temporary link table to Link *********************/
for (li = 0; li <= Link_Num; li++)
 {
 Link[li].Zone	= Addr[li].Zone;
 Link[li].Net	= Addr[li].Net;
 Link[li].Node	= Addr[li].Node;
 Link[li].Point = Addr[li].Point;
 Link[li].domain = Addr[li].domain;
 /*   Default TinySeenBys  ⮢   Tiny -   */
 if (Link[li].Point) Link[li].Tiny = 1; else Link[li].Tiny  = 0;
 Link[li].Gate	= 0;
 Link[li].AddSeen = 0;
 Link[li].Subscr = 0;
 Link[li].twitUUE = 0;
 Link[li].twitSize = 0;
 Link[li].outSize = 0;
 Link[li].arcSize = 0;
 Link[li].maxMsgs = 0;
 Link[li].holdTime = 0;
 Link[li].FwdBad = 0;
 Link[li].SBValid = 0;
 Link[li].Update = 0;
 Link[li].PKTPassword[0] = '\0';
 strcpy(Link[li].Packer, Def_Pack);
 Link[li].Lang[0] = Mm;
 Link[li].Lang[1] = Ss;
 Link[li].Lang[2] = Gg;
 Link[li].Lang[3] = '\0';
 Link[li].localPath = NULL;
 Link[li].OutAdd = 0UL;
 Link[li].OutMin = 0UL;
 Link[li].OutMax = 0UL;
 Link[li].OutExt[0] = '\0';
 }

#if MEMORY_FREE
free(Addr); /* free tmp table of links */
#endif

AllocCheck((Tag_Sum+2),Tag_Lin);
AllocCheck((Path_Sum+2),Path_Lin);
AllocCheck((Area_Num+2), Area);

dupsize = (unsigned long)(Cfg_Duplicates+2) * sizeof(*Dup);
lnksize = (unsigned long)(Link_Num+2) * sizeof(*Link_Tab);
arlsize = ((unsigned long)Area_Num+1) * (Link_Num + 2);

SizeAL = arlsize;

Free_Memory = farcoreleft();

/* Minimal memory requirement for 1 PKT, 10 msgs in it... */
Need_Memory = (Inb_Len + MAXFNAME + 3) + 10 * (sizeof(*Msg) + sizeof(*Msg_Tab))
     + sizeof(*PKTOrg) + sizeof(*PKTDest) + Tag_Len + Cfg_BufSize*5;

#if MEMORY_FREE
if ( dupsize > lnksize)
     Need_Memory += dupsize;
else Need_Memory += lnksize;
#else
Need_Memory += dupsize + lnksize;
#endif

Need_Memory += ((Twit_Num + 1) * sizeof(*Twit)) + (Twit_Sum + 2);
Need_Memory += arlsize;
Need_Memory += Size_Added;

PKT_Max = (unsigned int)((unsigned long)(Free_Memory - Need_Memory) /
	(Inb_Len + MAXFNAME + 3 + sizeof(*PKTOrg) + sizeof(*PKTDest)));
if (PKT_Max > 254) PKT_Max = 254;

AllocCheck(arlsize,AreaLink);

if (Need_Memory >= Free_Memory - 16384)
   Errexit (Lin_Memory, Erl_MemoryCFG);

/* ------------------- TwitFixer allocation -------------------------------- */
Twit = NULL;
Twit_Lin = NULL;
if (Twit_Num && !Twit_Off)
   {
   Twit = malloc((Twit_Num + 1) * sizeof(*Twit));
   Twit_Lin = malloc (Twit_Sum + 2);
   if ((Twit_Lin == NULL) || (Twit == NULL))
	{
	if (Twit_Lin != NULL) free(Twit_Lin); else;
	if (Twit != NULL) free(Twit); else;
	OutLog (LEV_WARN, "Low Memory! TwitFix is OFF");
	}
   else;
   } /* if Twit_Num */
else;
/******************* Fill AreaLink table with zero *************************/
for (l = 0; l < SizeAL; l++) AreaLink[l] = 0;
Sqw_cr3(); /* ====== Third Pass call ======================================= */
Sqw_cr4(); /* ====== Fourth Pass call ====================================== */
#if AREAFIX_STYLE
SizeOld = SizeNew = Tag_Sum + Path_Sum + (Area_Num * 8);
/*------------- Correct some paths if needed --------------------------------
 * If no NewAreaPath setted,  first   ᫨   ப NewAreaPath,  -
 * path  encountered  in   EchoArea    祭  ப EchoArea  
 * lines is used to build it.	      ᯮ ⮡  ந.
 *
 */
if (NewAreaPath == NULL)
	{ char *s0, *s1, c; int i;
	s0 = (char *)Path_Lin;
	for (i = 0; i < AREA1ST; i++) s0 += Area[i].Path;
	s1 = s0 + Area[AREA1ST].Path - 1;
	while ((s1 > s0) && (*s1 != BACKSLASH)) s1--;
	c = *s1; *s1 = '\0';
	AllocCheckConst(1,NewAreaPath);
	NewAreaPath->Mask = NULL;
	NewAreaPath->Next = NULL;
	AllocCpy(NewAreaPath->Line);
	*s1 = c;
	Sqw_pc(NewAreaPath->Line);
	}
else;
#else /* AREAFIX_STYLE */
if (Cfg_NewAreasCreate >= 2) Cfg_NewAreasCreate = 1; else;
#endif /* AREAFIX_STYLE */

#if MEMORY_FREE
free (Line);
#endif

if (ferror (filepkt)) Errexit("Error reading config file!",Erl_Config);
else fclose (filepkt);

/* ======================================================================= */
if (Config == NULL)
	{
	AllocCheckConst(3, Config);
	sprintf (Config, Format_c, BACKSLASH);
	Cfg_Len = 2;
	}
else;
if (FlagD == NULL)
	{
	AllocCheckConst(3, FlagD);
	sprintf (FlagD, Format_c, BACKSLASH);
	Flg_Len = 2;
	}
else;
squish_xfg = pathnew(squish_cfg);

/* ======================================================================== */
if ((Sqw_exist((char *)InBound,(char *)Temporary))||
    (Sqw_exist((char *)OutPath,(char *)Temporary))||
    (Sqw_exist((char *)FlagD,(char *)Temporary)))
   { char *tmp;
   if (Sqw_exist((char *)FlagD,renaming_flg))
      {
      tmp = "\nRenaming incomplete";
#if AREAFIX_STYLE
/*
 *   㦥  , ᪮쪮 ⠬ 뫮  宮⥩ - ⮬
 * ⪮஫஢ ࠧ  䠩  ⮫쪮   .
 */
      sqw_ren1(squish_xfg, squish_cfg, SizeOld, SizeOld);
#endif
      sqw_renflg(sqwacr_xat, sqwacr_bat);
      sqw_renflg(sqwash_xat, sqwash_bat);
      sqw_renflg(sqwish_xpb, sqwish_dpb);
      sqw_renflg(sqwish_xpc, sqwish_dpc);

      Sqw_ren ((char *)OutPath, (char *)InBound, Oo);
      if (Cfg_DupeFile == 1) Sqw_Dup_Ren(); else;
      } /* if exist renaming.flg */
   else {
	tmp = "\nTossing incomplete";
	remove (squish_xfg);
	sqw_delflg (sqwacr_xat);
	sqw_delflg (sqwash_xat);
	sqw_delflg (sqwish_xpb);
	sqw_delflg (sqwish_xpc);
	Sqw_ren ((char *)InBound, (char *)OutPath, Pp);
	if (Cfg_DupeFile == 1) Sqw_Dup_Del(); else;
	} /* else exist renaming.flg */
   puts(tmp);
   OutLog (LEV_WARN,tmp+1);
   } /* if exist Temporary */
flushall();
sqw_delflg (renaming_flg);
flushall();

if (Sqw_exist((char *)FlagD,renaming_flg))
      Errexit
      ("Can't delete renaming.flg - Continue working means loosing info!",
      Erl_Ren);
else;

if (Sqw_ir())/************* Find inbound *.~KT, create ~KT tables **********/
   { unsigned int tmp =
     (unsigned int)((unsigned long)Cfg_CacheSize * 1024 / (sizeof(mh) + 4));
   OutLog (LEV_TRIV,"Inbound file table created, inbound files renamed");
   AllocCheck(PKT_Num, PKTOrg);
   AllocCheck(PKT_Num, PKTDest);
   MSG_Max = (unsigned int)(((unsigned long)(Free_Memory - Need_Memory - 8192))/
		(sizeof(*Msg) + sizeof(*Msg_Tab)));
   MSG_Max -= 16;
   if ((MSG_Max > tmp) && (tmp > 0)) MSG_Max = tmp; else; /* ###029 */
   if ((signed int)MSG_Max <= 0) Errexit(Lin_Memory, Erl_Memory); else;
   do	{
	MSG_Max /= 2;
	Msg = malloc((unsigned long)MSG_Max * sizeof(*Msg));
	}
   while ((Msg == NULL) && (MSG_Max > 16));
   if (Msg == NULL) Errexit(Lin_Memory, Erl_Memory); else;
   printf ("Creating tables for %i messages max:\n", MSG_Max);

   Sqw_pr();	/************* Read inbound *.~KT, create MSG tables *********/

   MSG_Total = MSG_Num;
if (MSG_Num)	/* ###035 */
	{
	AllocCheck(MSG_Num, Msg_Tab);
	printf ("%u Messages summary...\n", MSG_Num);
	AllocCheck(Cfg_Duplicates, Dup);
	printf ("%u Duplicates allocated...\n", Cfg_Duplicates);
	flushall();


	Sqw_md();    /************* Dupes catching, writing SQWISH.~PB *******/

#if MEMORY_FREE
	free(Dup);
/** ###059 ࠭ free(Tag_Lin); */
#endif
	Sqw_ms();   /************* Sort message tables ***********************/
	AllocCheck(Link_Num, Link_Tab);
	for (i = 0; i < (WBD_MAX + 1); i++) wbd[i] = wbd0[i];

/* Read flag .NUM as starting number for out PKT names and MSGID unique nums */
sprintf(Buffer,Format_sz_s,FlagD,Format_s8lx_num + 8);
if (!findfirst(Buffer, &fileblk, (int)NULL))
   do	{
	sscanf(fileblk.ff_name,name8lx,(unsigned long *)&ttx);
	if (ttx > ttt) ttt = ttx; else;
	}
   while (!findnext(&fileblk));
else;

	Sqw_mw();   /************* Writing outbound packets ******************/
#if AREAFIX_STYLE
	Sqw_afix_update(); /* Writing new subscription table ***/
#endif /* AREAFIX_STYLE */

/* Write flag .NUM with new value fixed in it's name as hex number */
sprintf(Buffer,Format_s8lx_num, FlagD,(unsigned long)ttx); remove(Buffer);
sprintf(Buffer,Format_s8lx_num, FlagD, (unsigned long)ttt);
if ((fileout = fopen(Buffer,wb)) != NULL) fclose(fileout); else;

#if MEMORY_FREE
	free(Link_Tab);
	for (i = 0; i < (WBD_MAX + 1); i++)
		if (wbd[i] != wbd0[i]) free(wbd[i]); else;
#endif /* MEMORY_FREE */
	flushall();
	}
else;
	       /************* Final rename ***********************************/
   sprintf(Buffer, "Total %u messages", MSG_Total);
   OutLog (LEV_START, Buffer);
   sprintf(Buffer, Format_ss, FlagD, renaming_flg);
   if ((fileout = fopen(Buffer, wb)) != NULL)
	{
	OutLog (LEV_TRIV,"Renaming flag creating");
	fclose(fileout);
	}
      else OutLog (LEV_POSSIBLE, "Flag creation Error! It may cause packets loss.");
   flushall ();
   OutLog (LEV_TRIV,"Dupeboard file renaming");

#if AREAFIX_STYLE
   { NEW huge *new = New;	/* Add minimum size of added EchoArea lines  */
				/* to minsize of new file SquishCFG	     */
   while (new)
	{
	SizeNew += strlen(new->Line) + 27;
	new = new->Next;
	}
   } /* NEW huge *new = New */
   sqw_ren1(squish_xfg, squish_cfg, SizeNew, SizeOld);
#endif /* AREAFIX_STYLE */

   sqw_renflg(sqwacr_xat, sqwacr_bat);
   sqw_renflg(sqwash_xat, sqwash_bat);
#ifdef UNIX
/*
 * Change  status  of  batch/script      ⭮  䠩/ਯ
 * files to executable. 	       ᯮ塞.
 */
sprintf(Buffer, Format_ss, FlagD, sqwash_bat);
chmod(Buffer, S_IFREG | S_IRUSR | S_IWUSR | S_IXUSR);
sprintf(Buffer, Format_ss, FlagD, sqwacr_bat);
chmod(Buffer, S_IFREG | S_IRUSR | S_IWUSR | S_IXUSR);
#endif /* UNIX */
   sqw_renflg(sqwish_xpb, sqwish_dpb);
   sqw_renflg(sqwish_xpc, sqwish_dpc);

   if (Cfg_DupeFile == 1) Sqw_Dup_Ren(); else;
   Sqw_ren ((char *)OutPath, (char *)InBound, Oo);
   OutLog (LEV_TRIV,"Inbound deleted, Outbound renamed");
   flushall ();
   sprintf(Buffer, Format_ss, FlagD, renaming_flg);
   if (!remove (Buffer))
	OutLog (LEV_TRIV,"Renaming flag deleted");
   else OutLog (LEV_POSSIBLE,"Renaming flag deleting Error!");
   } /* if Sqw_ir */
else;
time(&time_finish);
if (MSG_Total)
 {
 if (time_finish <= time_begin) sprintf(Buffer,"Can't measure speed in msgs/sec");
 else sprintf(Buffer, "Tossed+sent %lu msgs per second",
			(unsigned long)MSG_Total/(time_finish - time_begin));
 OutLog(LEV_START, Buffer);
 }
else;
sprintf (Buffer, sVersion, "End.",
	SQW_VERTYPE, SQW_VERSION, SQW_SUBVERS, your_compiler);
if (RunExit)
   {
   OutLog(LEV_START,Buffer);
   sprintf(Buffer, "Executing %s\n", RunExit);
   OutLog(LEV_START,Buffer);
   flushall();
   sprintf (Buffer,"Can't execute RunExit line. execvp returned %i\n",
       execvp(RunExit,RunExit_argv()));
   Errexit(Buffer, Erl_RunExit);
   }
else Errexit(Buffer,0);
} /* main() */

/* ---------------------------------------------------------------------------
 * Create in static argv[] argument
 * list for RunExit execvp(). If no
 * room - exits. If too  long  com-
 * mand line - return 0;
 *
 */

static char **RunExit_argv()
{
static char *tmp;
static char **argv = NULL;
int i;

if (argv) return argv; else;

i = sprintf(Buffer,"%s @%s%s -c%s -n%s %s",
    RunExit, FlagD, sqwash_bat, compress_cfg, tossing_log, RunExit_param);
if (Cfg_MaxCommandLength && (i > Cfg_MaxCommandLength)) return NULL; else;
if ((tmp = malloc(i+4)) == NULL) return NULL; else;
strcpy(tmp,Buffer);
strtok(tmp,tabspace);
i = 1; while((strtok(NULL,tabspace)) != NULL) i++;
argv = malloc((i+1) * sizeof(void *));
if (argv == NULL) return NULL; else;

strcpy(tmp,Buffer);
strtok(tmp,tabspace);
argv[0] = RunExit;
i = 0;
while((argv[++i] = strtok(NULL, tabspace)) != NULL);
return argv;
} /* RunExit_argv() */

/*********************  ன, २   ன ********/
static void sqw_renflg(char *xat, char *bat)
{
char bufxat[MAXPATH+1];
if (Sqw_exist((char *)FlagD, xat))
	{
	sprintf(Buffer,Format_ss,FlagD,bat); remove (Buffer);
	sprintf(bufxat,Format_ss,FlagD,xat); rename (bufxat, Buffer);
	}
else;
} /* sqw_renflg */

#if AREAFIX_STYLE
/*********************  ன, २   ன *******/
static void sqw_ren1(char *xat, char *bat,
	unsigned long sizenew, unsigned long sizeold)
{
struct stat f;
char Format_size_of_sll[] =
       "Size of file %s is %lu, less than minimum possible %lu";

#if DEBUG
/**/Debug("sqw_ren1(\"%s\", \"%s\", %lu, %lu);\n", xat, bat, sizenew, sizeold);
#endif

if (stat(xat,&f)) return; else;
#if DEBUG
/**/Debug("sizenew = %lu; f.st_size = %lu;\n", sizenew, (unsigned long)f.st_size);
#endif
if (sizenew > (unsigned long)f.st_size)
      {
      sprintf(Buffer, Format_size_of_sll,
		xat, (unsigned long)f.st_size, sizenew);
      OutLog(LEV_LOOSE,Buffer);
/* - - - At this point new file is interpreted as invalid or not exist - -  */
      if (!stat(bat,&f))
	{
	if (sizeold > (unsigned long)f.st_size)
	     {
	     sprintf(Buffer, Format_size_of_sll,
		bat, (unsigned long)f.st_size, sizeold);
	     OutLog(LEV_LOOSE,Buffer);
	     }
	else OutLog2(LEV_POSSIBLE, bat, " - old file kept");
	remove(xat);
	} /* if (!stat(bat,&f)) */
      else
	{
	OutLog2(LEV_LOOSE, bat, " - old file not exist");
	rename(xat, bat);
	}
      } /* sizenew > size of (xat) */
else  {
      remove(bat);
      rename(xat,bat);
      } /* else sizenew >... */
} /* sqw_ren1() */
#endif /* AREAFIX_STYLE */
/*********************  䠩 *****************************************/
static void sqw_delflg(char *xat)
{
if (Sqw_exist((char *)FlagD, xat))
	{
	sprintf(Buffer,Format_ss,FlagD,xat);
	remove (Buffer);
	}
else;
} /* sqw_delflg */

/* - - - -          ண - - - - - *
 * "."         -> ".~"
 * "/"         -> "/.~"
 * "/test"     -> "/test.~"
 * "/test.cfg" -> "/test.~fg"
 */

static char *pathnew(char *oldpath)
{
char *newpath, *s0, *s1;
int  len = strlen(oldpath);

if (len > MAXPATH) return NULL; else;
newpath = malloc(len+4);
if (newpath)
   {
   strcpy(newpath,oldpath);
   s1 = newpath + len;
   s0 = s1 - 1;
   while ((s0 > newpath) && (*s0 != '.') && (*s0 != BACKSLASH)) s0--;
   if (*s0 == BACKSLASH) { s0++; *s0 = '.'; } else;
   if ((*s0 == '.') || (*s0 == BACKSLASH))
      {
      s0++;
      if (*s0 == '~') *s0++ = '#'; else *s0++ = '~';
      if (s0 > s1) *s0 = '\0';
      }
   else { *s1++ = '.'; *s1++ = '~'; *s1++ = '\0'; }
   } /* if newpath */
else;
return newpath;
}

/*********************      ᪮஢    ****/
void AllocPath(char *s0, char **s, int add_size, unsigned int *length)
{
s0 = Sqw_ph(s0);
*s = malloc(strlen(s0) + add_size);
if (*s == NULL) Errexit (Lin_Memory, Erl_MemoryCFG); else;
strcpy(*s,s0);
Sqw_pc(*s);
*length = strlen(*s);

if ((*length + add_size) >= MAXPATH)
  {
  sprintf (Buffer, "%s : Path plus %i chars is too long!", s0, add_size);
  Errexit (Buffer, Erl_Syntax);
  }
else;
DirCheck(*s, (*length)-1);
free(s0);
} /* AllocPath */
